#ifndef CHIP8_H
#define CHIP8_H

struct chip8_callbacks {
	/* called once per frame (60 Hz) */
	int (*tick)(void);

	/* called to draw a pixel */
	void (*draw)(int x, int y, int color);

	/* called to enable/disable beep (optional) */
	void (*sound)(int enable);

	/* check if key is pressed */
	int  (*getkey)(int key);

	/* wait for keypress */
	int  (*waitkey)(void);
};

void* chip8_create(struct chip8_callbacks*);
void  chip8_destroy(void*);

int   chip8_load(void*, const char*);
int   chip8_run(void*);

#endif /* CHIP8_H */
